﻿// --------------------------------------------------------------------------------------------------------------------
// <copyright file="CefHandlerKey.cs" company="Chromely Projects">
//   Copyright (c) 2017-2018 Chromely Projects
// </copyright>
// <license>
//      See the LICENSE.md file in the project root for more information.
// </license>
// --------------------------------------------------------------------------------------------------------------------

namespace Chromely.Core.Helpers
{
    /// <summary>
    /// The cef handler key.
    /// </summary>
    public enum CefHandlerKey
    {
        /// <summary>
        /// The none.
        /// </summary>
        None,

        /// <summary>
        /// The life span handler.
        /// </summary>
        LifeSpanHandler,

        /// <summary>
        /// The load handler.
        /// </summary>
        LoadHandler,

        /// <summary>
        /// The request handler.
        /// </summary>
        RequestHandler,

        /// <summary>
        /// The display handler.
        /// </summary>
        DisplayHandler,

        /// <summary>
        /// The context menu handler.
        /// </summary>
        ContextMenuHandler,

        /// <summary>
        /// The focus handler.
        /// </summary>
        FocusHandler,

        /// <summary>
        /// The keyboard handler.
        /// </summary>
        KeyboardHandler,

        /// <summary>
        /// The js dialog handler.
        /// </summary>
        JsDialogHandler,

        /// <summary>
        /// The dialog handler.
        /// </summary>
        DialogHandler,

        /// <summary>
        /// The drag handler.
        /// </summary>
        DragHandler,

        /// <summary>
        /// The download handler.
        /// </summary>
        DownloadHandler,

        /// <summary>
        /// The find handler.
        /// </summary>
        FindHandler 
    }
}
